; ================================================================================ 
;   darius/src/bg.asm                                                              
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.CODE

; ---------------------------------------------------------------- 
;   xbZ[W`                                             
;                                                                  
;   IN   : X = ^XNԍ                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, Y, TEMP+0, TEMP+1                                    
; ---------------------------------------------------------------- 
.DRAW_WARNING_MSG:
	LDY	TCB_COUNT1,X

	; bZ[WAhX
	MOV	TCB_WORK0,X, .WARNING_MSG_H,Y
	STA	<TEMP+1
	MOV	TCB_WORK1,X, .WARNING_MSG_L,Y
	STA	<TEMP+0

	; Jgʒu
	MOV	TCB_WORK2,X, #3

	; VRAM AhX
	LDY	#0
	MOV	TCB_WORK3,X, (TEMP),Y
	INY
	MOV	TCB_WORK4,X, (TEMP),Y
	INY

	; 
	MOV	TCB_WORK5,X, (TEMP),Y
	RTS


; ---------------------------------------------------------------- 
;   xf[^Rs[                                             
;                                                                  
;   IN   : X = f[^Jnʒu                                      
;   OUT  : Ȃ                                                    
;   BREAK: A, Y, X, TEMP                                           
; ---------------------------------------------------------------- 
.COPY_WARNING:
	LDY	<VRAM_DATA_COUNT

	LDA	#(19*2)
	STA	<TEMP
@@:
	LDA	.WARNING_DATA,X
	INX
	STA	VRAM_DATA_BUFF,Y
	INY
	DEC	<TEMP
	BNE	@B

	STY	<VRAM_DATA_COUNT
	RTS


; ---------------------------------------------------------------- 
;   ʏ\[h                                                 
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A                                                       
; ---------------------------------------------------------------- 
SET_BG_NORMAL:
	MOV	<SPR_EXT_ATTR,   #$00
	MOV	IRQ_LINE,        #24-1
	MOV	IRQ_ENABLE,      #$00

	PRE_CHG		PRE_IGNORE
	POST_CHG	POST_IGNORE
	RTS


; ---------------------------------------------------------------- 
;   bZ[W\[h                                           
;                                                                  
;   IN   : TEMP+0 = oNO                                       
;          TEMP+1 = oNP                                       
;          TEMP+2 = oNQ                                       
;          TEMP+3 = oNR                                       
;   OUT  : Ȃ                                                    
;   BREAK: A                                                       
; ---------------------------------------------------------------- 
SET_BG_MESSAGE:
	MOV	.ISR_CENTER_BANK0, <TEMP+0
	MOV	.ISR_CENTER_BANK1, <TEMP+1
	MOV	.ISR_CENTER_BANK2, <TEMP+2
	MOV	.ISR_CENTER_BANK3, <TEMP+3

	MOV	<.ISR_IRQ_PROC_H,  #HIGH(.ISR_IRQ_MESSAGE)
	MOV	<.ISR_IRQ_PROC_L,  #LOW(.ISR_IRQ_MESSAGE)
	MOV	<ISR_IRQ_PROC_H,   #HIGH(.ISR_IRQ_WALL_U)
	MOV	<ISR_IRQ_PROC_L,   #LOW(.ISR_IRQ_WALL_U)
	MOV	<SPR_EXT_ATTR,     #$20
	MOV	IRQ_LINE,          #24-1
	MOV	IRQ_ENABLE,        #$80

	PRE_CHG		.PRE_PROC_MESSAGE
	POST_CHG	.POST_PROC
	RTS


; ---------------------------------------------------------------- 
;   {X\[h                                                 
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A                                                       
; ---------------------------------------------------------------- 
SET_BG_BOSS:
	MOV	BOSS_BANK0,       BOSS0_INI_CHRBANK0
	MOV	BOSS_BANK1,       BOSS0_INI_CHRBANK1
	MOV	BOSS_BANK2,       BOSS0_INI_CHRBANK2
	MOV	BOSS_BANK3,       BOSS0_INI_CHRBANK3

	MOV	<.ISR_IRQ_PROC_H, #HIGH(.ISR_IRQ_BOSS)
	MOV	<.ISR_IRQ_PROC_L, #LOW(.ISR_IRQ_BOSS)
	MOV	<ISR_IRQ_PROC_H,  #HIGH(.ISR_IRQ_WALL_U)
	MOV	<ISR_IRQ_PROC_L,  #LOW(.ISR_IRQ_WALL_U)
	MOV	<SPR_EXT_ATTR,    #$00
	MOV	IRQ_LINE,         #24-1
	MOV	IRQ_ENABLE,       #$80

	PRE_CHG		.PRE_PROC_BOSS
	POST_CHG	.POST_PROC

	MOV	<.ISR_BG_NT,      <.BG_NT
	MOV	<.ISR_BG_XPOS,    <.BG_XPOS
	MOV	<.ISR_BG_YPOS,    <.BG_YPOS
	MOV	<.ISR_BG_ATTR,    <.BG_ATTR
	RTS


; ---------------------------------------------------------------- 
;   {Ẍʒuݒ                                               
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, Y, TEMP+0                                            
; ---------------------------------------------------------------- 
SET_BOSS_POS:
	STX	<TEMP+0

	; W
	LDA	#0
	SUB	TCB_XPOS_L+TASK_BOSS
	STA	<.BG_XPOS
	LDA	#0
	SBC	TCB_XPOS_H+TASK_BOSS
	BEQ	@F

	; if( TCB_XPOS_H == 0xff ) goto .SET_BOSS_POS_HIDE
	TAY
	INY
	BNE	.SET_BOSS_POS_HIDE

	LDA	#$04
@@:
	STA	<.BG_NT

	; W
	LDA	#16
	SUB	TCB_YPOS_L+TASK_BOSS
	TAY
	LDA	#0
	SBC	TCB_YPOS_H+TASK_BOSS
	BEQ	@F

	; if( TCB_YPOS_H != 0xff ) goto .SET_BOSS_POS_HIDE
	TAX
	INX
	BNE	.SET_BOSS_POS_HIDE

	; if( BOSS_YPOS_LO < 16 ) goto .SET_BOSS_POS_HIDE
	TYA
	SUB	#16
	BCC	.SET_BOSS_POS_HIDE

	JMP	.SET_BOSS_BG_POS_000

@@:
	TYA

	CMP	#240
	BCS	@F

	STA	<.BG_YPOS
	JMP	.SET_BOSS_BG_POS_0F0

@@:
	AND	#15

.SET_BOSS_BG_POS_000:
	STA	<.BG_YPOS
	LDA	<.BG_NT
	ORA	#$08
	STA	<.BG_NT

.SET_BOSS_BG_POS_0F0:
	; VRAM ʃAhX
	LDA	<.BG_XPOS
	LSR	A
	LSR	A
	LSR	A
	STA	<.BG_ATTR

	LDA	<.BG_YPOS
	AND	#$F8
	ASL	A
	ASL	A
	ORA	<.BG_ATTR
	STA	<.BG_ATTR
	LDX	<TEMP+0
	RTS


.SET_BOSS_POS_HIDE:
	; \
	MOV	<.BG_XPOS, #0
	JMP	.SET_BOSS_BG_POS_000


; ------------------------------------------------ 
;   x                                       
; ------------------------------------------------ 
.VRAM_PROC_CLEAR_WARNING:
	LDA	#$0

	; WARNING i
	SET_VRAM_ADDR	X, $2188
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA

	; WARNING i
	SET_VRAM_ADDR	X, $21A8
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA

	; bZ[WO
	SET_VRAM_ADDR	X, $21E7
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA

	; bZ[WP
	SET_VRAM_ADDR	X, $2227
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA

	; bZ[WQ
	SET_VRAM_ADDR	X, $2266
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	STA	PPU_REG_VRAM_DATA
	VRAM_PROC_RET


; ------------------------------------------------ 
;   _`                                       
; ------------------------------------------------ 
.VRAM_PROC_DRAW_SCORE:
	MOV	PPU_REG_VRAM_ADDR, #HIGH($2045)
	LDA	<UPDATE_SCORE
	TAX
	ADD	#LOW($2045)
	STA	PPU_REG_VRAM_ADDR
@@:
	LDA	<SCORE,X
	ADD	#($30+10)
	STA	PPU_REG_VRAM_DATA
	INX
	CPX	#7
	BNE	@B

	MOV	<UPDATE_SCORE, #$FF
	VRAM_PROC_RET


; ------------------------------------------------ 
;   O                                         
; ------------------------------------------------ 
.PRE_PROC_BOSS:
	MOV	<.ISR_CENTER_BANK0, <BOSS_BANK0
	MOV	<.ISR_CENTER_BANK1, <BOSS_BANK1
	MOV	<.ISR_CENTER_BANK2, <BOSS_BANK2
	MOV	<.ISR_CENTER_BANK3, <BOSS_BANK3
.PRE_PROC_MESSAGE:
	MOV	<.ISR_BG_NT,        <.BG_NT
	MOV	<.ISR_BG_XPOS,      <.BG_XPOS
	MOV	<.ISR_BG_YPOS,      <.BG_YPOS
	MOV	<.ISR_BG_ATTR,      <.BG_ATTR
	MOV	<.ISR_WALL_ATTR,    <.WALL_ATTR
	MOV	<.ISR_WALL_XPOS,    <.WALL_XPOS
	PRE_RET


; ------------------------------------------------ 
;   ㏈                                         
; ------------------------------------------------ 
.POST_PROC:
	LDA	<UPDATE_SCORE
	BPL	@F
	POST_RET

@@:
	; _`
	VRAM_PROC_ADD	.VRAM_PROC_DRAW_SCORE
	POST_RET


; ---------------------------------------------------------------- 
;   ǃXN[^XN쐬                                         
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, Y                                                    
; ---------------------------------------------------------------- 
CRE_WALL_SCROLL:
	TSK_CRE	Y, .TASK_WALL_SCROLL
	STA	<.ISR_WALL_XPOS
	RTS


; ------------------------------------------------ 
;   ǃXN[^XN                         
; ------------------------------------------------ 
.TASK_WALL_SCROLL:
	LDA	<.WALL_XPOS
	ADD	#3
	STA	<.WALL_XPOS
	LSR	A
	LSR	A
	LSR	A
	ORA	#((224 & $38) << 2)
	STA	<.WALL_ATTR

	; Xe[^X
	LDY	<SPR_BUFF_W

	; c@
	MOV	SPR_BUFF+SPR_XPOS,Y, #16
	MOV	SPR_BUFF+SPR_YPOS,Y, #7
	MOV	SPR_BUFF+SPR_PAT,Y,  #$00
	MOV	SPR_BUFF+SPR_ATTR,Y, #0
	ADD_Y	#4

	; Vbg
	MOV	SPR_BUFF+SPR_XPOS,Y, #8
	MOV	SPR_BUFF+SPR_YPOS,Y, #7
	MOV	SPR_BUFF+SPR_PAT,Y,  #$02
	MOV	SPR_BUFF+SPR_ATTR,Y, #$00
	ADD_Y	#4

	; ~TC
	MOV	SPR_BUFF+SPR_XPOS,Y, #44
	MOV	SPR_BUFF+SPR_YPOS,Y, #7
	MOV	SPR_BUFF+SPR_PAT,Y,  #$0A
	MOV	SPR_BUFF+SPR_ATTR,Y, #$02
	ADD_Y	#4

	; A[
	MOV	SPR_BUFF+SPR_XPOS,Y, #80
	MOV	SPR_BUFF+SPR_YPOS,Y, #7
	MOV	SPR_BUFF+SPR_PAT,Y,  #$08
	MOV	SPR_BUFF+SPR_ATTR,Y, #$03
	ADD_Y	#4

	STY	<SPR_BUFF_W

	ADD_TASK_QUE
	TSK_RET


; ---------------------------------------------------------------- 
;   ǃtF[hC^XN쐬                                       
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y                                                 
; ---------------------------------------------------------------- 
CRE_WALL_FADEIN:
	LDY	#0
	JMP	@F

; ---------------------------------------------------------------- 
;   ǃtF[hAEg^XN쐬                                     
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y                                                 
; ---------------------------------------------------------------- 
CRE_WALL_FADEOUT:
	LDY	#32
@@:
	TSK_CRE	X, .TASK_WALL_FADE
	MOV	TCB_COUNT0,X, #32
	TYA
	STA	TCB_COUNT2,X
	LDA	BOSS0_FADEIN_WALL,Y
	LDA	#LOW($3F09)
	JMP	SET_PAL_DATA


; ------------------------------------------------ 
;   ǃtF[hCEAEg^XN               
; ------------------------------------------------ 
.TASK_WALL_FADE:
	DEC	TCB_COUNT0,X
	BNE	@F

	INC	TCB_COUNT2,X
	LDA	TCB_COUNT2,X
	AND	#3
	BEQ	.WALL_FADE_0F0

	MOV	TCB_COUNT0,X, #32

	LDY	TCB_COUNT2,X
	LDA	BOSS0_FADEIN_WALL,Y
	TAY
	LDA	#LOW($3F09)
	JSR	SET_PAL_DATA
@@:
	ADD_TASK_QUE
	TSK_RET


.WALL_FADE_0F0:
	PUT_TASK_NO
	TSK_RET


; ---------------------------------------------------------------- 
;   xbZ[W^XN쐬                                       
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y, TEMP+0, TEMP+1                                 
; ---------------------------------------------------------------- 
CRE_WARNING:
	; WARNING _Ń^XN쐬
	TSK_CRE	X, .TASK_WARNING_BLINK

	; WARNING bZ[W^XN쐬
	TSK_CRE	X, .TASK_WARNING_MSG
	MOV	TCB_COUNT0,X, #1
	MOV	TCB_COUNT1,X, #0
	JMP	.DRAW_WARNING_MSG


; ------------------------------------------------ 
;   x_Ń^XN                             
; ------------------------------------------------ 
.TASK_WARNING_BLINK:
	LDA	<SYS_STATUS
	BNE	.TASK_WARNING_BLINK_0F0

	ADD_TASK_QUE

	LDA	<TICK_COUNT
	AND	#31
	BNE	.TASK_WARNING_BLINK_000

	; WARNING Rs[
	LDX	#0
	LDA	<TICK_COUNT
	AND	#32
	BEQ	@F

	LDX	#(19*2)
@@:
	JSR	.COPY_WARNING

.TASK_WARNING_BLINK_000:
	TSK_RET


.TASK_WARNING_BLINK_0F0:
	PUT_TASK_NO
	TSK_RET


; ------------------------------------------------ 
;   xbZ[W^XN                       
; ------------------------------------------------ 
.TASK_WARNING_MSG:
	ADD_TASK_QUE

	DEC	TCB_COUNT0,X
	BNE	.TASK_WARNING_MSG_0F0

	LDA	#8
	STA	TCB_COUNT0,X

	; TEMP = bZ[WAhX
	MOV	<TEMP+1, TCB_WORK0,X
	MOV	<TEMP+0, TCB_WORK1,X

	LDY	TCB_WORK2,X
	INC	TCB_WORK2,X

	; }CiXȂ ZONE ɕϊ
	LDA	(TEMP),Y
	BPL	@F

	LDA	#'A'
	ADD	<STAGE
@@:
	LDY	<VRAM_DATA_COUNT

	STA	VRAM_DATA_BUFF+VRAM_DATA,Y
	MOV	VRAM_DATA_BUFF+VRAM_H,Y, TCB_WORK3,X
	LDA	TCB_WORK4,X
	INC	TCB_WORK4,X
	STA	VRAM_DATA_BUFF+VRAM_L,Y
	MOV	VRAM_DATA_BUFF+VRAM_COUNT,Y, #1
	ADD_Y	#4

	STY	<VRAM_DATA_COUNT

	DEC	TCB_WORK5,X
	BNE	.TASK_WARNING_MSG_0F0

	INC	TCB_COUNT1,X
	LDA	#3
	CMP	TCB_COUNT1,X
	BEQ	.TASK_WARNING_MSG_080

	JSR	.DRAW_WARNING_MSG
	TSK_RET


.TASK_WARNING_MSG_080:
	TSK_CHG	.TASK_WARNING_MSG_CLEAR

	; 
	LDA	#240
	STA	TCB_COUNT0,X

.TASK_WARNING_MSG_0F0:
	TSK_RET


.TASK_WARNING_MSG_CLEAR:
	DEC	TCB_COUNT0,X
	BEQ	@F

	ADD_TASK_QUE
	TSK_RET

@@:
	; pbg
	LDY	#0
	LDA	#LOW($3F01)
	JSR	SET_PAL_DATA

	; xbZ[WNA
	VRAM_PROC_ADD	.VRAM_PROC_CLEAR_WARNING

	INC	<SYS_STATUS

	PUT_TASK_NO
	TSK_RET


; ------------------------------------------------ 
;   Ǐ㕔荞                                 
; ------------------------------------------------ 
.ISR_IRQ_WALL_U:
	PHA

	LDA	MMC5_INT
	LDA	PPU_REG_STATUS
	MOV	MMC5_INT_LINE, #40-1

	MOV	<ISR_IRQ_PROC_H, <.ISR_IRQ_PROC_H
	MOV	<ISR_IRQ_PROC_L, <.ISR_IRQ_PROC_L

	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP

	MOV	PPU_REG_CTRL2,  #PPU_CTRL2_BG
	MOV	PPU_REG_SCROLL, <.ISR_WALL_XPOS

	PLA
	RTI


; ------------------------------------------------ 
;   bZ[W\荞                         
; ------------------------------------------------ 
.ISR_IRQ_MESSAGE:
	PHA
	TXA
	PHA
	TYA
	PHA

	LDA	MMC5_INT
	MOV	MMC5_INT_LINE, #216-1

	MOV	<ISR_IRQ_PROC_H, #HIGH(.ISR_IRQ_WALL_D)
	MOV	<ISR_IRQ_PROC_L, #LOW(.ISR_IRQ_WALL_D)

	LDA	PPU_REG_STATUS

	; oNݒ
	LDX	<.ISR_CENTER_BANK0
	LDY	<.ISR_CENTER_BANK1
	STX	MMC5_BG_BANK0
	STY	MMC5_BG_BANK1
	LDX	<.ISR_CENTER_BANK2
	LDY	<.ISR_CENTER_BANK3
	STX	MMC5_BG_BANK2
	STY	MMC5_BG_BANK3

	MOV	PPU_REG_CTRL2,  #(PPU_CTRL2_SPR|PPU_CTRL2_BG)
	MOV	PPU_REG_SCROLL, #0

	PLA
	TAY
	PLA
	TAX
	PLA
	RTI


; ------------------------------------------------ 
;   {X\荞                               
; ------------------------------------------------ 
.ISR_IRQ_BOSS:
	PHA
	TXA
	PHA
	TYA
	PHA

	LDA	MMC5_INT
	MOV	MMC5_INT_LINE, #216-1
	MOV	<ISR_IRQ_PROC_H, #HIGH(.ISR_IRQ_WALL_D)
	MOV	<ISR_IRQ_PROC_L, #LOW(.ISR_IRQ_WALL_D)

	LDA	PPU_REG_STATUS

	NOP
	NOP

	MOV	PPU_REG_CTRL2, #(PPU_CTRL2_SPR|PPU_CTRL2_BG)

	; ʒuݒ
	MOV	PPU_REG_VRAM_ADDR, <.ISR_BG_NT
	LDA	<.ISR_BG_YPOS
	LDX	<.ISR_BG_XPOS
	LDY	<.ISR_BG_ATTR
	STA	PPU_REG_SCROLL
	STX	PPU_REG_SCROLL
	STY	PPU_REG_VRAM_ADDR

	; l[e[u}bsOύX
	MOV	MMC5_NT_MAP, #%11111110

	; oNݒ
	LDX	<.ISR_CENTER_BANK0
	LDY	<.ISR_CENTER_BANK1
	STX	MMC5_BG_BANK0
	STY	MMC5_BG_BANK1
	LDX	<.ISR_CENTER_BANK2
	LDY	<.ISR_CENTER_BANK3
	STX	MMC5_BG_BANK2
	STY	MMC5_BG_BANK3

	PLA
	TAY
	PLA
	TAX
	PLA
	RTI


; ------------------------------------------------ 
;   ǉ\荞                             
; ------------------------------------------------ 
.ISR_IRQ_WALL_D:
	PHA
	TXA
	PHA
	TYA
	PHA

	; l[e[u}bsOύX
	MOV	MMC5_NT_MAP, #%11111111

	NOP
	NOP
	NOP
	NOP
	NOP

	LDA	PPU_REG_STATUS

	LDX	<BG_BANK2
	LDY	<BG_BANK3
	STX	MMC5_BG_BANK2
	STY	MMC5_BG_BANK3

	; ʒuݒ
	MOV	PPU_REG_VRAM_ADDR, #(((224&$C0)>>6) | ((224&$03)<<4))
	LDA	#224
	LDX	<.ISR_WALL_XPOS
	LDY	<.ISR_WALL_ATTR
	STA	PPU_REG_SCROLL
	STX	PPU_REG_SCROLL
	STY	PPU_REG_VRAM_ADDR

	; oNݒ
	LDX	<BG_BANK0
	LDY	<BG_BANK1
	STX	MMC5_BG_BANK0
	STY	MMC5_BG_BANK1

	; l[e[u}bsOύX
	MOV	MMC5_NT_MAP, #%00000000

	LDA	MMC5_INT
	MOV	MMC5_INT_LINE, #0
	MOV	<ISR_IRQ_PROC_H, #HIGH(.ISR_IRQ_WALL_U)
	MOV	<ISR_IRQ_PROC_L, #LOW(.ISR_IRQ_WALL_U)

	MOV	PPU_REG_CTRL2, #PPU_CTRL2_BG

	PLA
	TAY
	PLA
	TAX
	PLA
	RTI


.WARNING_DATA:		.DB	$21,$88, 16, $12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$18,$19,$1C,$1D,$1E,$1F	; i
			.DB	$21,$A8, 16, $22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$28,$29,$2C,$2D,$2E,$2F	; i
			.DB	$21,$88, 16, $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; iNA
			.DB	$21,$A8, 16, $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; iNA

.WARNING_MSG0:		.DB	$21,$E7, 17, 'A', 0, 'H','U','G','E', 0, 'B','A','T','T','L','E','S','H','I','P'
.WARNING_MSG2:		.DB	$22,$66, 19, 'I','S', 0, 'A','P','P','R','O','A','C','H','I','N','G',  0,'F','A','S','T'

.WARNING_MSG_H:		.DB	HIGH(.WARNING_MSG0), HIGH(BOSS0_WARNING_MSG), HIGH(.WARNING_MSG2)
.WARNING_MSG_L:		.DB	 LOW(.WARNING_MSG0),  LOW(BOSS0_WARNING_MSG),  LOW(.WARNING_MSG2)




	.ZP

.ISR_BG_NT:		.DS	1				; 荞݃T[rX[`̃{Xl[e[u
.ISR_BG_XPOS:		.DS	1				; 荞݃T[rX[`̂W
.ISR_BG_YPOS:		.DS	1				; 荞݃T[rX[`̂W
.ISR_BG_ATTR:		.DS	1				; 荞݃T[rX[`̑
.ISR_WALL_ATTR:		.DS	1				; 荞݃T[rX[`̕ǃXN[
.ISR_WALL_XPOS:		.DS	1				; 荞݃T[rX[`̕ǃXN[W
.ISR_IRQ_PROC:							; 荞݃T[rX[`̎ IRQ 荞ݏ
.ISR_IRQ_PROC_L:	.DS	1				;
.ISR_IRQ_PROC_H:	.DS	1				;
.ISR_CENTER_BANK0:	.DS	1				; wioNO
.ISR_CENTER_BANK1:	.DS	1				; wioNP
.ISR_CENTER_BANK2:	.DS	1				; wioNQ
.ISR_CENTER_BANK3:	.DS	1				; wioNR
.BG_XPOS:		.DS	1				; W
.BG_YPOS:		.DS	1				; W
.BG_NT:			.DS	1				; {Xl[e[u
.BG_ATTR:		.DS	1				; 
.WALL_XPOS:		.DS	1				; ǃXN[
.WALL_ATTR:		.DS	1				; ǃXN[W
