; ================================================================================ 
;   darius/src/enemy.asm                                                           
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.CODE

; ---------------------------------------------------------------- 
;   GeO^XN쐬                                               
;                                                                  
;   IN   : TEMP+0 = px                                           
;          TEMP+1 = x                                           
;          TEMP+2 = WʂWrbg                             
;          TEMP+3 = WʂWrbg                             
;          TEMP+4 = WʂWrbg                             
;          TEMP+5 = WʂWrbg                             
;   OUT  : Ȃ                                                    
;   BREAK: A, Y                                                    
; ---------------------------------------------------------------- 
CRE_BULLET0:
	TSK_CRE	Y, .TASK_BULLET0
	MOV	TCB_ANGLE,Y,    <TEMP+0
	MOV	TCB_SPEED,Y,    <TEMP+1
	MOV	TCB_XPOS_H,Y,   <TEMP+2
	MOV	TCB_XPOS_L,Y,   <TEMP+3
	MOV	TCB_YPOS_H,Y,   <TEMP+4
	MOV	TCB_YPOS_L,Y,   <TEMP+5
	MOV	TCB_HIT_TYPE,Y, #COMM_HIT_EBULLET0
	MOV	TCB_XPOS_F,Y,   #0
	STA	TCB_YPOS_F,Y
	STA	TCB_HIT,Y
	RTS


; ------------------------------------------------ 
;   GeO^XN                               
; ------------------------------------------------ 
.TASK_BULLET0:
	ADD_TASK_QUE
	TSK_CHG	.TASK_BULLET0_000

	LDA	#COMM_TBL_EBULLET
	JSR	SET_ACT
	JSR	SET_SPR_BUFF
	JSR	ADD_HIT_QUE
	TSK_RET


.TASK_BULLET0_000:
	LDA	TCB_HIT,X
	BNE	@F

	JSR	MOVE_ANGLE

	; ʊOȂI
	LDA	TCB_XPOS_H,X
	ORA	TCB_YPOS_H,X
	BMI	@F

	ADD_TASK_QUE

	JSR	ACT_TASK
	JSR	SET_SPR_BUFF
	JSR	ADD_HIT_QUE
	TSK_RET

@@:
	PUT_TASK_NO
	TSK_RET


; ---------------------------------------------------------------- 
;   G[U[O^XN쐬                                         
;                                                                  
;   IN   : TEMP+0 = x                                           
;          TEMP+1 = WʂWrbg                             
;          TEMP+2 = WʂWrbg                             
;          TEMP+3 = WʂWrbg                             
;          TEMP+4 = WʂWrbg                             
;   OUT  : Ȃ                                                    
;   BREAK: A, Y                                                    
; ---------------------------------------------------------------- 
CRE_LASER0:
	TSK_CRE	Y, .TASK_LASER0
	MOV	TCB_SPEED,Y,  <TEMP+0
	MOV	TCB_XPOS_H,Y, <TEMP+1
	MOV	TCB_XPOS_L,Y, <TEMP+2
	MOV	TCB_YPOS_H,Y, <TEMP+3
	MOV	TCB_YPOS_L,Y, <TEMP+4
	MOV	TCB_XPOS_F,Y, #0
	STA	TCB_YPOS_F,Y
	RTS


; ------------------------------------------------ 
;   [U[O^XN                           
; ------------------------------------------------ 
.TASK_LASER0:
	ADD_TASK_QUE
	TSK_CHG	.TASK_LASER0_000

	LDA	#COMM_TBL_ELASER
	JSR	SET_ACT
	JSR	SET_SPR_BUFF
	TSK_RET


.TASK_LASER0_000:
	LDA	TCB_XPOS_L,X
	SUB	TCB_SPEED,X
	STA	TCB_XPOS_L,X
	LDA	TCB_XPOS_H,X
	SBC	#0
	STA	TCB_XPOS_H,X

	; ʊOȂI
	LDA	TCB_XPOS_H,X
	BMI	@F

	ADD_TASK_QUE

	JSR	ACT_TASK
	JSR	SET_SPR_BUFF
	JSR	ADD_HIT_QUE
	TSK_RET

@@:
	PUT_TASK_NO
	TSK_RET


; ---------------------------------------------------------------- 
;   j[he쐬                                               
;                                                                  
;   IN   : TEMP+0 = px                                           
;          TEMP+1 = x                                           
;          TEMP+2 = WʂWrbg                             
;          TEMP+3 = WʂWrbg                             
;          TEMP+4 = WʂWrbg                             
;          TEMP+5 = WʂWrbg                             
;   OUT  : Ȃ                                                    
;   BREAK: A, Y                                                    
; ---------------------------------------------------------------- 
CRE_NEEDLE_BULLET:
	TSK_CRE	Y, .TASK_NEEDLE_BULLET
	MOV	TCB_ANGLE,Y,    <TEMP+0
	MOV	TCB_SPEED,Y,    <TEMP+1
	MOV	TCB_XPOS_H,Y,   <TEMP+2
	MOV	TCB_XPOS_L,Y,   <TEMP+3
	MOV	TCB_YPOS_H,Y,   <TEMP+4
	MOV	TCB_YPOS_L,Y,   <TEMP+5
	MOV	TCB_COUNT0,Y,   #8
	MOV	TCB_HIT_TYPE,Y, #COMM_HIT_ENEMY0
	MOV	TCB_XPOS_F,Y,   #0
	STA	TCB_YPOS_F,Y
	STA	TCB_COUNT1,Y
	STA	TCB_HIT,Y
	RTS


; ------------------------------------------------ 
;   j[he^XN                           
; ------------------------------------------------ 
.TASK_NEEDLE_BULLET:
	JSR	.MOVE_NEEDLE_BULLET

	DEC	TCB_COUNT0,X
	BNE	@F

	TSK_CHG	.TASK_NEEDLE_BULLET_000
@@:
	TSK_RET


.TASK_NEEDLE_BULLET_000:
	JSR	.MOVE_NEEDLE_BULLET

	MOV	TCB_COUNT0,X, #6
	MOV	TCB_SPEED,X,  #(4*4)

	; px擾
	LDY	#TASK_PLAYER
	JSR	GET_ANGLE
	STA	TCB_COUNT3,X

	SUB	TCB_ANGLE,X
	BPL	@F

	TSK_CHG	.TASK_NEEDLE_BULLET_100
	TSK_RET

@@:
	TSK_CHG	.TASK_NEEDLE_BULLET_180
	TSK_RET


.TASK_NEEDLE_BULLET_100:
	JSR	.MOVE_NEEDLE_BULLET

	LDA	TCB_ANGLE,X
	SUB	#4
	STA	TCB_ANGLE,X

	SUB	TCB_COUNT3,X
	BMI	@F
	TSK_RET

.TASK_NEEDLE_BULLET_180:
	JSR	.MOVE_NEEDLE_BULLET

	LDA	TCB_ANGLE,X
	ADD	#4
	STA	TCB_ANGLE,X

	ADD	TCB_COUNT3,X
	BPL	@F
	TSK_RET

@@:
	TSK_CHG	.TASK_NEEDLE_BULLET_200
	MOV	TCB_ANGLE,X, TCB_COUNT3,X
	TSK_RET


.TASK_NEEDLE_BULLET_200:
	JSR	.MOVE_NEEDLE_BULLET

	DEC	TCB_COUNT0,X
	BNE	@F

	MOV	TCB_COUNT0,X, #6

	; px擾
	LDY	#TASK_PLAYER
	JSR	GET_ANGLE
	STA	TCB_COUNT3,X

	SUB	TCB_ANGLE,X
	AND	#32
	BEQ	.TASK_NEEDLE_BULLET_240

	LDA	TCB_ANGLE,X
	SUB	#4
	STA	TCB_ANGLE,X
	TSK_RET

.TASK_NEEDLE_BULLET_240:
	LDA	TCB_ANGLE,X
	ADD	#4
	STA	TCB_ANGLE,X
@@:
	TSK_RET


; ------------------------------------------------ 
;   j[he^XN                       
; ------------------------------------------------ 
.TASK_NEEDLE_BULLET_EXPLOSION:
	; ߂AhXj
	PLA
	PLA

	; _
	LDA	TCB_HIT,X
	BMI	@F

	LDA	#1
	LDX	#5
	JSR	ADD_SCORE
@@:
	LDY	#COMM_TBL_EXPLOSION_S

; ------------------------------------------------ 
;   ^XN                                 
; ------------------------------------------------ 
.TASK_EXPLOSION:
	TSK_CHG	.TASK_EXPLOSION_000
	MOV	TCB_COUNT0,X, #0

	TYA
	JSR	SET_ACT
	JSR	SET_SPR_BUFF

	ADD_TASK_QUE
	TSK_RET


.TASK_EXPLOSION_000:
	JSR	ACT_TASK
	BCS	@F

	JSR	MOVE_ANGLE

	; ʊOȂI
	LDA	TCB_XPOS_H,X
	ORA	TCB_YPOS_H,X
	BNE	@F

	ADD_TASK_QUE

	JSR	SET_SPR_BUFF
	TSK_RET

@@:
	PUT_TASK_NO
	TSK_RET


; ---------------------------------------------------------------- 
;   j[heړ                                                 
;                                                                  
;   IN   : X = ^XNԍ                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, Y                                                    
; ---------------------------------------------------------------- 
.MOVE_NEEDLE_BULLET:
	LDA	TCB_HIT,X
	BNE	.TASK_NEEDLE_BULLET_EXPLOSION

	JSR	MOVE_ANGLE

	; ʊOȂj
	LDA	TCB_XPOS_H,X
	ORA	TCB_YPOS_H,X
	BNE	@F

	LDA	TCB_COUNT1,X
	EOR	#1
	STA	TCB_COUNT1,X

	; p^[ԍ擾
	LDA	TCB_ANGLE,X
	ADD	#8
	LSR	A
	LSR	A
	LSR	A
	LSR	A
	AND	#14
	ORA	TCB_COUNT1,X
	ADD	#COMM_TBL_NBULLET
	TAY
	MOV	TCB_PAT,X, COMM_TBL_PAT,Y

	ADD_TASK_QUE

	JSR	SET_SPR_BUFF
	JMP	ADD_HIT_QUE

@@:
	; ߂AhXj
	PLA
	PLA

	PUT_TASK_NO
	TSK_RET


; ---------------------------------------------------------------- 
;   V@^XN쐬                                             
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, Y                                                    
; ---------------------------------------------------------------- 
CRE_DRIFTING_MINE:
	TSK_CRE	Y, .TASK_DRIFTING_MINE
	MOV	TCB_SPEED,Y,    #8
	MOV	TCB_XPOS_L,Y,   #200
	MOV	TCB_YPOS_L,Y,   #172
	MOV	TCB_ANGLE,Y,    #0
	STA	TCB_XPOS_H,Y
	STA	TCB_YPOS_H,Y
	STA	TCB_XPOS_F,Y
	STA	TCB_YPOS_F,Y
	STA	TCB_HIT,Y
	MOV	TCB_COUNT0,Y,   #5
	RTS


; ------------------------------------------------ 
;   V@^XN                             
; ------------------------------------------------ 
.TASK_DRIFTING_MINE:
	ADD_TASK_QUE

	LDA	#COMM_TBL_DRIFTINGMINE
	JSR	SET_ACT

	TSK_CHG	.TASK_DRIFTING_MINE_000
	TSK_RET


.TASK_DRIFTING_MINE_000:
	LDY	TCB_HIT,X
	BEQ	@F

	MOV	TCB_HIT,X, #0

	; _
	LDA	#1
	LDX	#6
	JSR	ADD_SCORE

	DEC	TCB_COUNT0,X
	BEQ	.TASK_DRIFTING_MINE_0F0

@@:
	JSR	MOVE_ANGLE
	DEC	TCB_ANGLE,X
	DEC	TCB_ANGLE,X

	ADD_TASK_QUE

	JSR	ACT_TASK
	JSR	SET_SPR_BUFF
	JSR	ADD_HIT_QUE
	TSK_RET


.TASK_DRIFTING_MINE_0F0:
	LDY	#COMM_TBL_EXPLOSION_S
	JMP	.TASK_EXPLOSION


; ---------------------------------------------------------------- 
;   YJE^J[~B^XN쐬                                   
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, Y                                                    
; ---------------------------------------------------------------- 
CRE_YAZUKS_MINE:
	TSK_CRE	Y, .TASK_YAZUKA
	MOV	TCB_SPEED,Y,    #10
	MOV	TCB_XPOS_L,Y,   #180
	MOV	TCB_YPOS_L,Y,   #0
	STA	TCB_ANGLE,Y
	STA	TCB_XPOS_H,Y
	STA	TCB_YPOS_H,Y
	STA	TCB_XPOS_F,Y
	STA	TCB_YPOS_F,Y
	STA	TCB_HIT,Y
	MOV	TCB_COUNT0,Y,   #5
	RTS


; ------------------------------------------------ 
;   YJE^J[~B^XN                   
; ------------------------------------------------ 
.TASK_YAZUKA:
	ADD_TASK_QUE

	LDA	#COMM_TBL_YAZUKA
	JSR	SET_ACT

	TSK_CHG	.TASK_YAZUKA_000
	TSK_RET


.TASK_YAZUKA_000:
	LDY	TCB_HIT,X
	BEQ	@F

	MOV	TCB_HIT,X, #0

	; _
	LDA	#3
	LDX	#5
	JSR	ADD_SCORE

	DEC	TCB_COUNT0,X
	BEQ	.TASK_YAZUKA_0F0

@@:
	JSR	MOVE_ANGLE
	LDA	TCB_ANGLE,X
	ADD	#4
	STA	TCB_ANGLE,X

	ADD_TASK_QUE

	JSR	ACT_TASK
	JSR	SET_SPR_BUFF
	JSR	ADD_HIT_QUE
	TSK_RET


.TASK_YAZUKA_0F0:
	LDY	#COMM_TBL_EXPLOSION_S
	JMP	.TASK_EXPLOSION
