; ================================================================================ 
;   darius/src/main.asm                                                            
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.INCLUDE "data/bank.inc"
	.INCLUDE "src/regs.inc"
	.INCLUDE "src/define.inc"
	.INCLUDE "src/work.asm"


; ------------------------------------------------ 
;   pbhԂ擾                               
; ------------------------------------------------ 
.GET_PADSTATE	.MACRO
	LDA	$4016
	AND	#3
	CMP	#1
	ROL	<PAD_NORM
	.ENDM


	.CODE


; ------------------------------------------------------------------------------------------------ 
;   BANK : 0                                                                                       

	.BANK	0
	.ORG	$8000

TITLE_NT:
	.INCBIN  "data/bin/Title.nam"

.GAMEBASE0_DATA:	.DB	$E6,$E7,$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E0,$E1,$E2,$E3,$E4,$E5
			.DB	$F6,$F7,$F0,$F1,$F2,$FF,$F4,$F5,$F6,$F7,$F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F0,$F1,$F2,$F3,$F4,$F5

.GAMEBASE1_DATA:	.DB	$C2,$C3,$C4,$C5,$C6,$C7,$C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C0,$C1
			.DB	$D2,$D3,$D4,$D5,$D6,$D7,$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D0,$D1

.GAMEBASE_ATTR:		.DB	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			.DB	$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
			.DB	$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
			.DB	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			.DB	$F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0
			.DB	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			.DB	$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
			.DB	$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA


; ------------------------------------------------ 
;   ^XNԍ                               
; ------------------------------------------------ 
INI_TASK_NO:
	LDX	#0
	STX	<TASK_QUE_W
	STX	<TASK_QUE_R

	LDY	#TASK_RESERVED_MAX
@@:
	TYA
	STA	TASK_NO,X
	INX
	INY
	CPX	#(TASK_MAX-TASK_RESERVED_MAX)
	BNE	@B

	STX	<TASK_COUNT
	RTS


; ------------------------------------------------ 
;                                            
; ------------------------------------------------ 
.INIT:
	; X^bN|C^ݒ
	LDX	#LOW(STACK+STACK_SIZE-1)
	TXS

	MOV	$4017, #(1<<6)					; t[V[PT
	MOV	$5204, #$00					; 荞݋֎~
	MOV	$5010, #$00					; PCM 荞݋֎~ECg[h

	JSR	WAIT_VBLANK
	JSR	WAIT_VBLANK

	; RAM 
	LDA	#$00
	TAX
@@:
	STA	$0000,X
	STA	$0100,X
	STA	$0200,X
	STA	$0300,X
	STA	$0400,X
	STA	$0500,X
	STA	$0600,X
	STA	$0700,X
	STA	$6000,X
	STA	$6100,X
	STA	$6200,X
	STA	$6300,X
	STA	$6400,X
	STA	$6500,X
	STA	$6600,X
	STA	$6700,X
	STA	$6800,X
	STA	$6900,X
	STA	$6A00,X
	STA	$6B00,X
	STA	$6C00,X
	STA	$6D00,X
	STA	$6E00,X
	STA	$6F00,X
	STA	$7000,X
	STA	$7100,X
	STA	$7200,X
	STA	$7300,X
	STA	$7400,X
	STA	$7500,X
	STA	$7600,X
	STA	$7700,X
	STA	$7800,X
	STA	$7900,X
	STA	$7A00,X
	STA	$7B00,X
	STA	$7C00,X
	STA	$7D00,X
	STA	$7E00,X
	STA	$7F00,X
	INX
	BNE	@B

	; IRQ ݒi$4C = JMP ߁j
	MOV	<ISR_IRQ, #$4C

	; ^XNԍ
	JSR	INI_TASK_NO

	; MMC5 
	MOV	MMC5_CHR_BANK_H, #$00				; oNݒʃrbgNA
	MOV	MMC5_ERAM_MODE,  #$02				; g RAM [hݒ
	MOV	MMC5_WRAM_WP1,   #%00000010			; ݕی
	MOV	MMC5_WRAM_WP2,   #%00000001			;
	MOV	MMC5_NT_MAP,     #%00000000			; l[e[u}bsO
	MOV	$5106,           #0
	STA	$5107

	; LN^[ ROM oN 
	MOV	MMC5_CHR_MODE, #$03
	MOV	<BG_BANK0,      #BANK_BG_BASE0
	MOV	<BG_BANK1,      #BANK_BG_BASE1
	MOV	<BG_BANK2,      #BANK_BG_BASE2
	MOV	<BG_BANK3,      #BANK_BG_BASE3
	MOV	MMC5_SPR_BANK0, #BANK_SPR_BASE0
	MOV	MMC5_SPR_BANK1, #BANK_SPR_BASE1
	MOV	MMC5_SPR_BANK2, #BANK_SPR_BASE2
	MOV	MMC5_SPR_BANK3, #BANK_SPR_BASE3
	MOV	MMC5_SPR_BANK4, #BANK_SPR_BASE4
	MOV	MMC5_SPR_BANK5, #BANK_SPR_BASE5
	MOV	MMC5_SPR_BANK6, #BANK_BOSS0_SPR0
	MOV	MMC5_SPR_BANK7, #BANK_BOSS0_SPR1
	MOV	MMC5_BG_BANK0,  #BANK_BG_BASE0
	MOV	MMC5_BG_BANK1,  #BANK_BG_BASE1
	MOV	MMC5_BG_BANK2,  #BANK_BG_BASE2
	MOV	MMC5_BG_BANK3,  #BANK_BG_BASE3

	MOV	$4014, #HIGH(SPR_BUFF)

	; VXe
	SYS_CHG		SYSTEM_TITLE
	PRE_CHG		PRE_IGNORE
	POST_CHG	POST_IGNORE

	JSR	WAIT_VBLANK

	; PPU ݒ
	MOV	PPU_REG_CTRL2, #(PPU_CTRL2_SPR|PPU_CTRL2_BG)
	MOV	PPU_REG_CTRL1, #(PPU_CTRL1_INT|PPU_CTRL1_SPR16|PPU_CTRL1_BG0|PPU_CTRL1_SPR0|PPU_CTRL1_ADD1|PPU_CTRL1_NT0)
	LDA	PPU_REG_STATUS

	CLI

	JMP	MAIN


; ------------------------------------------------ 
;   Q[ʂ`                               
; ------------------------------------------------ 
DRAW_GAME_SCREEN:
	; 㕔NA
	SET_VRAM_ADDR	$2000
	LDA	#$00
	LDX	#128
@@:	STA	PPU_REG_VRAM_DATA
	DEX
	BNE	@B

	; 
	LDX	#$00
@@:	LDA	.GAMEBASE0_DATA,X
	STA	PPU_REG_VRAM_DATA
	INX
	CPX	#64
	BNE	@B

	; NA
	LDA	#$00
	LDY	#$03
	LDX	#$C0
@@:	STA	PPU_REG_VRAM_DATA
	DEX
	BNE	@B
	DEY
	BNE	@B

	; 
	LDX	#$00
@@:	LDA	.GAMEBASE1_DATA,X
	STA	PPU_REG_VRAM_DATA
	INX
	CPX	#64
	BNE	@B

	; Q[ʑ
	LDX	#$00
@@:	LDA	.GAMEBASE_ATTR,X
	STA	PPU_REG_VRAM_DATA
	INX
	CPX	#64
	BNE	@B

	; ][
	SET_VRAM_ADDR	$205B			; i
	MOV	PPU_REG_VRAM_DATA, #$7B
	MOV	PPU_REG_VRAM_DATA, #$7C
	MOV	PPU_REG_VRAM_DATA, #$7D

	SET_VRAM_ADDR	$207B			; i
	MOV	PPU_REG_VRAM_DATA, #$7E
	LDA	<STAGE
	ADD	#$61
	STA	PPU_REG_VRAM_DATA
	MOV	PPU_REG_VRAM_DATA, #$7F

	; c@
	SET_VRAM_ADDR	$2043
	LDA	<PLAYER_COUNT
	ADD	#$30
	STA	PPU_REG_VRAM_DATA

	; _
	LDX	#6
.DRAW_SCREEN_000:
	LDA	<SCORE,X
	CMP	#-10
	BNE	.DRAW_SCREEN_040
	LDA	#$20
	STA	<TEMP,X
	DEX
	BPL	.DRAW_SCREEN_000
	JMP	.DRAW_SCREEN_0F0

.DRAW_SCREEN_040:
	LDA	<SCORE,X
	ADD	#($30+10)
	STA	<TEMP,X
	DEX
	BPL	.DRAW_SCREEN_040

.DRAW_SCREEN_0F0:
	SET_VRAM_ADDR	$2045
	MOV	PPU_REG_VRAM_DATA, <TEMP+6
	MOV	PPU_REG_VRAM_DATA, <TEMP+5
	MOV	PPU_REG_VRAM_DATA, <TEMP+4
	MOV	PPU_REG_VRAM_DATA, <TEMP+3
	MOV	PPU_REG_VRAM_DATA, <TEMP+2
	MOV	PPU_REG_VRAM_DATA, <TEMP+1
	MOV	PPU_REG_VRAM_DATA, <TEMP+0
	MOV	PPU_REG_VRAM_DATA, #$30

	; Vbgx`
	SET_VRAM_ADDR	$2062
	LDA	<SHOOT_LEVEL
	AND	#7
	TAY
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT0,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT1,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT2,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT3,Y

	; {x`
	LDA	<BOMB_LEVEL
	AND	#7
	TAY
	MOV	PPU_REG_VRAM_DATA, BOMB_LEVEL_DAT0,Y
	MOV	PPU_REG_VRAM_DATA, BOMB_LEVEL_DAT1,Y
	MOV	PPU_REG_VRAM_DATA, BOMB_LEVEL_DAT2,Y
	MOV	PPU_REG_VRAM_DATA, BOMB_LEVEL_DAT3,Y

	; 
	MOV	PPU_REG_VRAM_DATA, #0

	; A[x`
	LDA	<ARM_LEVEL
	AND	#7
	TAY
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT0,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT1,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT2,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT3,Y
	RTS




; ------------------------------------------------------------------------------------------------ 
;   BANK : 1                                                                                       

	.BANK	1
	.ORG	$8000

PCM_DAT:
	.INCBIN  "data/bin/pcm.dat"




; ------------------------------------------------------------------------------------------------ 
;   BANK : 2                                                                                       

	.BANK	2
	.ORG	$A000

BOSS0:
BOSS0_NT:
	.INCBIN  "data/bin/Dari_King_kihon.nam"
	.INCLUDE "data/boss0_data.asm"
	.INCLUDE "src/boss0.asm"




; ------------------------------------------------------------------------------------------------ 
;   BANK : 3                                                                                       

	.BANK	3
	.ORG	$A000

BOSS1:
BOSS1_NT:
	.INCBIN  "data/bin/Dari_Ele_kihon.nam"
	.INCLUDE "data/boss1_data.asm"
	.INCLUDE "src/boss1.asm"




; ------------------------------------------------------------------------------------------------ 
;   BANK : 4                                                                                       

	.BANK	4
	.ORG	$A000

BOSS2:
BOSS2_NT:
	.INCBIN  "data/bin/Dari_Guard_kihon.nam"
	.INCLUDE "data/boss2_data.asm"
	.INCLUDE "src/boss2.asm"




; ------------------------------------------------------------------------------------------------ 
;   BANK : PRG_BANK_MAX-2                                                                          

	.BANK	PRG_BANK_MAX-2, 0
	.ORG	$C000


	.INCLUDE "data/comm_data.asm"

; VbgEA[xf[^
SHOOT_ARM_LEVEL_DAT0:	.DB	$08,$07,$06,$06,$06,$06,$06,$06
SHOOT_ARM_LEVEL_DAT1:	.DB	$08,$08,$08,$07,$06,$06,$06,$06
SHOOT_ARM_LEVEL_DAT2:	.DB	$08,$08,$08,$08,$08,$07,$06,$06
SHOOT_ARM_LEVEL_DAT3:	.DB	$0A,$0A,$0A,$0A,$0A,$0A,$0A,$09

; {xf[^
BOMB_LEVEL_DAT0:	.DB	$0C,$0B,$0B,$0B,$0B,$0B,$0B,$0B
BOMB_LEVEL_DAT1:	.DB	$08,$08,$07,$06,$06,$06,$06,$06
BOMB_LEVEL_DAT2:	.DB	$08,$08,$08,$08,$07,$06,$06,$06
BOMB_LEVEL_DAT3:	.DB	$08,$08,$08,$08,$08,$08,$07,$06


	.ORG	$C600

; TCf[^
SIN_DATA:	.DB	$00,$02,$04,$05,$07,$08,$0A,$0B,$0D,$0F,$10,$12,$13,$15,$16,$18
		.DB	$19,$1A,$1C,$1D,$1F,$20,$21,$23,$24,$25,$27,$28,$29,$2A,$2B,$2D
		.DB	$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37,$37,$38,$39,$3A,$3A,$3B
		.DB	$3C,$3C,$3D,$3D,$3E,$3E,$3F,$3F,$3F,$40,$40,$40,$40,$40,$40,$40
		.DB	$40,$40,$40,$40,$40,$40,$40,$40,$3F,$3F,$3F,$3E,$3E,$3D,$3D,$3C
		.DB	$3C,$3B,$3A,$3A,$39,$38,$37,$37,$36,$35,$34,$33,$32,$31,$30,$2F
		.DB	$2E,$2D,$2B,$2A,$29,$28,$27,$25,$24,$23,$21,$20,$1F,$1D,$1C,$1A
		.DB	$19,$18,$16,$15,$13,$12,$10,$0F,$0D,$0B,$0A,$08,$07,$05,$04,$02
		.DB	$80,$82,$84,$85,$87,$88,$8A,$8B,$8D,$8F,$90,$92,$93,$95,$96,$98
		.DB	$99,$9A,$9C,$9D,$9F,$A0,$A1,$A3,$A4,$A5,$A7,$A8,$A9,$AA,$AB,$AD
		.DB	$AE,$AF,$B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B7,$B8,$B9,$BA,$BA,$BB
		.DB	$BC,$BC,$BD,$BD,$BE,$BE,$BF,$BF,$BF,$C0,$C0,$C0,$C0,$C0,$C0,$C0
		.DB	$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$BF,$BF,$BF,$BE,$BE,$BD,$BD,$BC
		.DB	$BC,$BB,$BA,$BA,$B9,$B8,$B7,$B7,$B6,$B5,$B4,$B3,$B2,$B1,$B0,$AF
		.DB	$AE,$AD,$AB,$AA,$A9,$A8,$A7,$A5,$A4,$A3,$A1,$A0,$9F,$9D,$9C,$9A
		.DB	$99,$98,$96,$95,$93,$92,$90,$8F,$8D,$8B,$8A,$88,$87,$85,$84,$82


	.ORG	$C700

; pxf[^
ANGLE_DATA:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		.DB	$40,$20,$12,$0D,$09,$08,$06,$05,$05,$04,$04,$03,$03,$03,$02,$02
		.DB	$40,$2D,$20,$17,$12,$0F,$0D,$0B,$09,$08,$08,$07,$06,$06,$05,$05
		.DB	$40,$32,$28,$20,$1A,$16,$12,$10,$0E,$0D,$0B,$0A,$09,$09,$08,$08
		.DB	$40,$36,$2D,$25,$20,$1B,$17,$15,$12,$11,$0F,$0E,$0D,$0C,$0B,$0A
		.DB	$40,$37,$30,$29,$24,$20,$1C,$19,$16,$14,$12,$11,$10,$0E,$0D,$0D
		.DB	$40,$39,$32,$2D,$28,$23,$20,$1C,$1A,$17,$16,$14,$12,$11,$10,$0F
		.DB	$40,$3A,$34,$2F,$2A,$26,$23,$20,$1D,$1A,$18,$17,$15,$14,$12,$11
		.DB	$40,$3A,$36,$31,$2D,$29,$25,$22,$20,$1D,$1B,$19,$17,$16,$15,$13
		.DB	$40,$3B,$37,$32,$2E,$2B,$28,$25,$22,$20,$1D,$1B,$1A,$18,$17,$16
		.DB	$40,$3B,$37,$34,$30,$2D,$29,$27,$24,$22,$20,$1E,$1C,$1A,$19,$17
		.DB	$40,$3C,$38,$35,$31,$2E,$2B,$28,$26,$24,$21,$20,$1E,$1C,$1B,$19
		.DB	$40,$3C,$39,$36,$32,$2F,$2D,$2A,$28,$25,$23,$21,$20,$1E,$1C,$1B
		.DB	$40,$3C,$39,$36,$33,$31,$2E,$2B,$29,$27,$25,$23,$21,$20,$1E,$1D
		.DB	$40,$3D,$3A,$37,$34,$32,$2F,$2D,$2A,$28,$26,$24,$23,$21,$20,$1E
		.DB	$40,$3D,$3A,$37,$35,$32,$30,$2E,$2C,$29,$28,$26,$24,$22,$21,$20


	.INCLUDE "src/common.asm"
	.INCLUDE "src/system.asm"
	.INCLUDE "src/hit.asm"
	.INCLUDE "src/bg.asm"
	.INCLUDE "src/player.asm"
	.INCLUDE "src/enemy.asm"
	.INCLUDE "src/boss.asm"


	.CODE


; ------------------------------------------------ 
;   VSYNC 荞݃T[rX[`                 
; ------------------------------------------------ 
.ISR_VSYNC;
	PHA

	LDA	PPU_REG_STATUS
	INC	<VSYNC_FLAG
	INC	<TICK_COUNT
	MOV	PPU_REG_SCROLL, #0
	MOV	PPU_REG_SCROLL, #8

	LDA	MMC5_INT
	MOV	MMC5_INT_LINE, IRQ_LINE
	MOV	MMC5_INT,      IRQ_ENABLE

	PLA
	RTI


; ------------------------------------------------ 
;   C                                     
; ------------------------------------------------ 
MAIN:
	; VSync ҂
	MOV	<VSYNC_FLAG, #0
@@:	LDA	<VSYNC_FLAG
	BEQ	@B

	; XvCg]
	MOV	$4014, #HIGH(SPR_BUFF)

	; VRAM f[^Rs[
	LDA	<VRAM_DATA_COUNT
	BEQ	.COPY_VRAMDATA_0F0

	LDX	#0
.COPY_VRAMDATA_000:
	MOV	PPU_REG_VRAM_ADDR, VRAM_DATA_BUFF+VRAM_H,X	; VRAM ʃAhX
	MOV	PPU_REG_VRAM_ADDR, VRAM_DATA_BUFF+VRAM_L,X	; VRAM ʃAhX
	LDY	VRAM_DATA_BUFF+VRAM_COUNT,X			; f[^
	ADD_X	#3

@@:	MOV	PPU_REG_VRAM_DATA, VRAM_DATA_BUFF,X
	INX
	DEY
	BNE	@B
	CPX	<VRAM_DATA_COUNT
	BNE	.COPY_VRAMDATA_000

	MOV	<VRAM_DATA_COUNT, #0
.COPY_VRAMDATA_0F0:

	; VRAM 쏈
	LDA	<VRAM_PROC_COUNT
	BEQ	.VRAM_PROC_0F0
@@:
	DEC	<VRAM_PROC_COUNT
	LDX	<VRAM_PROC_COUNT
	MOV	<TEMP+1, VRAM_PROC_BUFF_H,X
	MOV	<TEMP+0, VRAM_PROC_BUFF_L,X
	JMP	(TEMP)
VRAM_PROC_EXIT:

	LDX	<VRAM_PROC_COUNT
	BNE	@B
.VRAM_PROC_0F0:

	MOV	PPU_REG_CTRL2,  #(PPU_CTRL2_SPR|PPU_CTRL2_BG)
	MOV	PPU_REG_CTRL1,  #(PPU_CTRL1_INT|PPU_CTRL1_SPR16|PPU_CTRL1_BG0|PPU_CTRL1_SPR0|PPU_CTRL1_ADD1|PPU_CTRL1_NT0)
	MOV	PPU_REG_SCROLL, #0
	MOV	PPU_REG_SCROLL, #8

	; O
	JMP	(PRE_PROC)
PRE_EXIT:

	; Õpbh
	MOV	<PAD_OLD, <PAD_NORM

	; pbhԂ擾
	MOV_X	$4016, #$01
	STX	<PAD_NORM
	DEX
	STX	$4016
	.GET_PADSTATE
	.GET_PADSTATE
	.GET_PADSTATE
	.GET_PADSTATE
	.GET_PADSTATE
	.GET_PADSTATE
	.GET_PADSTATE
	.GET_PADSTATE

	; pbhԈx̂
	LDA	<PAD_NORM
	EOR	<PAD_OLD
	AND	<PAD_NORM
	STA	<PAD_ONCE

	; VXe
	JMP	(SYS_PROC)
SYS_EXIT:

	; 
	MOV	HIT_PLAYER, #0
	STA	HIT_BULLET_COUNT
	STA	HIT_BULLET_QUE
	STA	HIT_QUE0
	STA	HIT_QUE1
	STA	HIT_QUE2
	STA	HIT_QUE3

	; ^XN
.TASK_PROC:
	LDA	<TASK_QUE_W
	TAX
	EOR	<TASK_QUE_R
	BEQ	.TASK_PROC_0F0

	STX	<TASK_QUE_E

@@:
	LDY	<TASK_QUE_R
	LDX	TASK_QUE,Y

	STX	<TASK_RUN
	MOV	<TEMP+1, TCB_PROC_H,X
	MOV	<TEMP+0, TCB_PROC_L,X
	JMP	(TEMP)
TASK_EXIT:

	INC	<TASK_QUE_R
	LDA	<TASK_QUE_R
	EOR	<TASK_QUE_E
	BNE	@B
.TASK_PROC_0F0:

	; ㏈
	JMP	(POST_PROC)
POST_EXIT:

	; `FbN
	JSR	HIT_CHECK

	; XvCgobt@c
	LDX	<SPR_BUFF_W
;#	CPX	<SPR_BUFF_H
;#	BEQ	.CRE_SPR_BUFF_0F0

	LDA	#$FF
@@:
	STA	SPR_BUFF,X
	ADD_X	#4
	CPX	<SPR_BUFF_H
	BNE	@B

;.CRE_SPR_BUFF_0F0:
	LDA	<SPR_BUFF_H
	ADC	#144-1
	STA	<SPR_BUFF_H
	STA	<SPR_BUFF_W

	JMP	MAIN


; ------------------------------------------------ 
;   Zbg                                       
; ------------------------------------------------ 
	.BANK	PRG_BANK_MAX-1
	.ORG	$FFE1

.RESET:
	SEI
	CLD
	MOV	MMC5_PRG_MODE, #$03
	MOV	MMC5_PRG_8000, #$80+BANK(.INIT)
	MOV	MMC5_PRG_A000, #$80+1
	MOV	MMC5_PRG_C000, #$80+(PRG_BANK_MAX-2)
	JMP	.INIT


; ------------------------------------------------ 
;   荞݃xN^e[u                         
; ------------------------------------------------ 
	.ORG	$FFFA

.INT_VECT:
	.DW	.ISR_VSYNC
	.DW	.RESET
	.DW	ISR_IRQ
