; ================================================================================ 
;   darius/src/system.asm                                                          
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.CODE

; ---------------------------------------------------------------- 
;   XvCgobt@֐ݒ                                       
;                                                                  
;   IN   : TEMP+7 = J[\ʒu                                   
;   OUT  : Ȃ                                                    
;   BREAK: A, X, Y                                                 
; ---------------------------------------------------------------- 
.SET_SPR_BUFF:
	LDY	<SPR_BUFF_W

	; J[\
	LDX	<TEMP+7
	MOV	SPR_BUFF+SPR_PAT,Y,  #0
	MOV	SPR_BUFF+SPR_ATTR,Y, #$00
	MOV	SPR_BUFF+SPR_XPOS,Y, #72
	MOV	SPR_BUFF+SPR_YPOS,Y, .TITLE_CURSOR_YPOS,X
	ADD_Y	#4

	; Vbg
	LDA	<SETUP_SHOOT_LEVEL
	AND	#~7
	LSR	A
	LSR	A
	ADC	#$02
	STA	SPR_BUFF+SPR_PAT,Y
	MOV	SPR_BUFF+SPR_ATTR,Y, #$00
	MOV	SPR_BUFF+SPR_XPOS,Y, #88
	MOV	SPR_BUFF+SPR_YPOS,Y, #175
	ADD_Y	#4

	; {
	LDA	<SETUP_BOMB_LEVEL
	AND	#~7
	LSR	A
	LSR	A
	ADC	#$0A
	STA	SPR_BUFF+SPR_PAT,Y
	MOV	SPR_BUFF+SPR_ATTR,Y, #$02
	MOV	SPR_BUFF+SPR_XPOS,Y, #88
	MOV	SPR_BUFF+SPR_YPOS,Y, #183
	ADD_Y	#4

	; A[
	MOV	SPR_BUFF+SPR_PAT,Y,  #$08
	MOV	SPR_BUFF+SPR_ATTR,Y, #$03
	MOV	SPR_BUFF+SPR_XPOS,Y, #88
	MOV	SPR_BUFF+SPR_YPOS,Y, #191
	ADD_Y	#4

	STY	<SPR_BUFF_W
	RTS


; ---------------------------------------------------------------- 
;   ARM pbgݒ                                             
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A, X                                                    
; ---------------------------------------------------------------- 
.SET_ARM_PAL:
	LDA	<SETUP_ARM_LEVEL
	LSR	A
	LSR	A
	LSR	A
	TAX
	LDY	.ARM_PAL_DATA,X
	LDA	#LOW($3F3D)
	JMP	SET_PAL_DATA


; ------------------------------------------------ 
;   ^Cg                                       
; ------------------------------------------------ 
SYSTEM_TITLE:

	; ʔ펞{荞݋֎~
	MOV	PPU_REG_CTRL2, #0
	MOV	PPU_REG_CTRL1, #PPU_CTRL1_NT0

	; LN^[ ROM oN
	MOV	MMC5_SPR_BANK0, #BANK_SPR_BASE0

	; pbg
	WRITE_PAL	 0, 3
	WRITE_PAL	12, 3
	WRITE_PAL	16, 7
	WRITE_PAL	24, 9
	WRITE_PAL	28, 13

	; l[e[u쐬
	SET_VRAM_ADDR	$2000
	LDX	#0
@@:	LDA	TITLE_NT+$0000,X
	STA	PPU_REG_VRAM_DATA
	INX
	BNE	@B

@@:	LDA	TITLE_NT+$0100,X
	STA	PPU_REG_VRAM_DATA
	INX
	BNE	@B

@@:	LDA	TITLE_NT+$0200,X
	STA	PPU_REG_VRAM_DATA
	INX
	BNE	@B

@@:	LDA	TITLE_NT+$0300,X
	STA	PPU_REG_VRAM_DATA
	INX
	BNE	@B

	; Vbgx
	SET_VRAM_ADDR	$230C
	LDA	<SETUP_SHOOT_LEVEL
	AND	#7
	TAY
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT0,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT1,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT2,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT3,Y

	; {x
	SET_VRAM_ADDR	$232C
	LDA	<SETUP_BOMB_LEVEL
	AND	#7
	TAY
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT0,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT1,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT2,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT3,Y

	; A[x
	SET_VRAM_ADDR	$234C
	LDA	<SETUP_ARM_LEVEL
	AND	#7
	TAY
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT0,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT1,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT2,Y
	MOV	PPU_REG_VRAM_DATA, SHOOT_ARM_LEVEL_DAT3,Y

	; J[\ʒu
	MOV	<TEMP+7, #0

	JSR	.SET_SPR_BUFF

	SYS_CHG	.TITLE_MAIN

.WAIT_EXIT:
	JSR	WAIT_VBLANK

	LDA	MMC5_INT
	MOV	PPU_REG_SCROLL, #0
	MOV	PPU_REG_SCROLL, #8
	MOV	PPU_REG_CTRL2,  #(PPU_CTRL2_SPR|PPU_CTRL2_BG)
	MOV	PPU_REG_CTRL1,  #(PPU_CTRL1_INT|PPU_CTRL1_SPR16|PPU_CTRL1_BG0|PPU_CTRL1_SPR0|PPU_CTRL1_ADD1|PPU_CTRL1_NT0)
	SYS_RET


; ------------------------------------------------ 
;   ^CgC                                 
; ------------------------------------------------ 
.TITLE_MAIN:
	LDA	<PAD_ONCE
	BEQ	.TITLE_0F0

	AND	#(PAD_UP+PAD_DOWN)
	BEQ	@F

	; pbh㉺ړ
	AND	#PAD_UP
	ORA	<TEMP+7
	TAY
	LDA	.TITLE_CURSOR_DOWN,Y
	STA	<TEMP+7
	JMP	.TITLE_0F0

@@:	LDA	#PAD_START
	BIT	<PAD_ONCE
	BEQ	@F

	; pbh START {^
	JMP	.TITLE_SEL_GAMESTART

@@:	LDA	#PAD_A
	BIT	<PAD_ONCE
	BEQ	@F

	; pbh A {^
	LDX	<TEMP+7
	MOV	<TEMP+1, .TITLE_SEL_A_H,X
	MOV	<TEMP+0, .TITLE_SEL_A_L,X
	JMP	(TEMP)

@@:	LDA	#PAD_LEFT
	BIT	<PAD_ONCE
	BEQ	@F

	; pbh
	LDX	<TEMP+7
	MOV	<TEMP+1, .TITLE_SEL_L_H,X
	MOV	<TEMP+0, .TITLE_SEL_L_L,X
	JMP	(TEMP)

@@:	LDA	#PAD_RIGHT
	BIT	<PAD_ONCE
	BEQ	.TITLE_0F0

	; pbhE
	LDX	<TEMP+7
	MOV	<TEMP+1, .TITLE_SEL_R_H,X
	MOV	<TEMP+0, .TITLE_SEL_R_L,X
	JMP	(TEMP)


.TITLE_0F0:
.TITLE_SEL_NONE:
	JSR	.SET_SPR_BUFF
	JSR	.SET_ARM_PAL
	SYS_RET


; ------------------------------------------------ 
;   GAME START Jn                                
; ------------------------------------------------ 
.TITLE_SEL_GAMESTART:
	; -------------------------------- 
	;   PCM Đ                       
	; -------------------------------- 
	.IF	DEBUG_PCM = 1
		MOV	PPU_REG_CTRL1, #(PPU_CTRL1_SPR16|PPU_CTRL1_BG0|PPU_CTRL1_SPR0|PPU_CTRL1_ADD1|PPU_CTRL1_NT0)

		; PCM f[^I
		MOV	MMC5_PRG_8000, #$80+BANK(PCM_DAT)

		; PCM Đ
		MOV	<TEMP+1, #HIGH($8000)
		MOV	<TEMP+0, #LOW($8000)
		LDY	#0
.TITLE_SEL_GAMESTART_000:
		LDA	(TEMP),Y
		BEQ	.TITLE_SEL_GAMESTART_0F0

		STA	$5011

		LDA	<TEMP+0
		ADD	#1
		STA	<TEMP+0

		LDA	<TEMP+1
		ADC	#0
		STA	<TEMP+1

		LDX	#80
@@:		DEX
		BNE	@B
		JMP	.TITLE_SEL_GAMESTART_000

.TITLE_SEL_GAMESTART_0F0:
		JSR	WAIT_VBLANK

		MOV	PPU_REG_CTRL1, #(PPU_CTRL1_INT|PPU_CTRL1_SPR16|PPU_CTRL1_BG0|PPU_CTRL1_SPR0|PPU_CTRL1_ADD1|PPU_CTRL1_NT0)
	.ENDIF

	SYS_CHG	SYSTEM_GAME
	SYS_RET


; ------------------------------------------------ 
;   Iڂ`{^                           
; ------------------------------------------------ 
.TITLE_SEL_WEAPON_A:
	LDX	<TEMP+7
	SUB_X	#2
	LDA	<SETUP_SHOOT_LEVEL,X
	ADD	#8
	CMP	#24
	BCC	@F

	AND	#7
@@:
	STA	<SETUP_SHOOT_LEVEL,X
	JMP	.TITLE_0F0


; ------------------------------------------------ 
;   ZONE ڍ                                    
; ------------------------------------------------ 
.TITLE_SEL_ZONE_L:
	LDX	<SETUP_STAGE
	DEX
	BPL	.TITLE_SEL_ZONE

	LDX	#(.BOSS_DATA_BANK_END-.BOSS_DATA_BANK)-1
	JMP	.TITLE_SEL_ZONE

; ------------------------------------------------ 
;   ZONE ډE                                    
; ------------------------------------------------ 
.TITLE_SEL_ZONE_R:
	LDX	<SETUP_STAGE
	INX
	CPX	#(.BOSS_DATA_BANK_END-.BOSS_DATA_BANK)
	BCC	.TITLE_SEL_ZONE

	LDX	#0

.TITLE_SEL_ZONE:
	STX	<SETUP_STAGE

	; VRAM 
	LDY	<VRAM_DATA_COUNT
	MOV	VRAM_DATA_BUFF+VRAM_H,Y,     #HIGH($22F0)
	MOV	VRAM_DATA_BUFF+VRAM_L,Y,     #LOW($22F0)
	MOV	VRAM_DATA_BUFF+VRAM_COUNT,Y, #1
	TXA
	CLC
	ADC	#'A'
	STA	VRAM_DATA_BUFF+VRAM_DATA,Y
	ADD_Y	#4
	STY	<VRAM_DATA_COUNT

	JMP	.TITLE_0F0


; ------------------------------------------------ 
;   Iڍ                                 
; ------------------------------------------------ 
.TITLE_SEL_WEAPON_L:
	LDX	<TEMP+7
	DEX
	DEX
	DEC	<SETUP_SHOOT_LEVEL,X
	BPL	.TITLE_WRITE_LEVEL

	MOV	<SETUP_SHOOT_LEVEL,X, #23
	JMP	.TITLE_WRITE_LEVEL


; ------------------------------------------------ 
;   IډE                                 
; ------------------------------------------------ 
.TITLE_SEL_WEAPON_R:
	LDX	<TEMP+7
	DEX
	DEX
	INC	<SETUP_SHOOT_LEVEL,X
	LDA	#23
	CMP	<SETUP_SHOOT_LEVEL,X
	BCS	.TITLE_WRITE_LEVEL

	MOV	<SETUP_SHOOT_LEVEL,X, #0

.TITLE_WRITE_LEVEL:
	LDA	<SETUP_SHOOT_LEVEL,X
	AND	#7
	TAX

	LDA	<TEMP+7
	SUB	#2
	AND	#3
	CLC
	ROR	A
	ROR	A
	ROR	A
	ROR	A
	ADC	#$0C

	; VRAM 
	LDY	<VRAM_DATA_COUNT
	STA	VRAM_DATA_BUFF+VRAM_L,Y
	MOV	VRAM_DATA_BUFF+VRAM_H,Y,      #HIGH($2300)
	MOV	VRAM_DATA_BUFF+VRAM_COUNT,Y,  #4
	MOV	VRAM_DATA_BUFF+VRAM_DATA+0,Y, SHOOT_ARM_LEVEL_DAT0,X
	MOV	VRAM_DATA_BUFF+VRAM_DATA+1,Y, SHOOT_ARM_LEVEL_DAT1,X
	MOV	VRAM_DATA_BUFF+VRAM_DATA+2,Y, SHOOT_ARM_LEVEL_DAT2,X
	MOV	VRAM_DATA_BUFF+VRAM_DATA+3,Y, SHOOT_ARM_LEVEL_DAT3,X
	TYA
	ADD	#7
	STA	<VRAM_DATA_COUNT

	JMP	.TITLE_0F0


; ---------------------------------------------------------------- 
;   Q[                                                         
; ---------------------------------------------------------------- 
SYSTEM_GAME:
	; ʔ\{荞݋֎~
	MOV	PPU_REG_CTRL2, #0
	MOV	PPU_REG_CTRL1, #PPU_CTRL1_NT0

	; 
	MOV	<WALL_TOP,      #16
	MOV	<WALL_BOTTOM,   #191
	MOV	<SYS_STATUS,    #0
	MOV	<STAGE,         <SETUP_STAGE
	MOV	<PLAYER_COUNT,  #2
	MOV_Y	<SHOOT_LEVEL,   <SETUP_SHOOT_LEVEL
	MOV	<SHOOT_TBL,     .SHOOTINFO_TBL,Y
	MOV	<SHOOT_SPEED,   .SHOOTINFO_SPEED,Y
	MOV	<SHOOT_SPEED_F, .SHOOTINFO_SPEED_F,Y
	MOV	<SHOOT_COUNT,   .SHOOTINFO_COUNT,Y
	MOV	<BOMB_LEVEL,    <SETUP_BOMB_LEVEL
	MOV	<ARM_LEVEL,     <SETUP_ARM_LEVEL
	MOV	<ARM_COUNT,     #3
	MOV	<UPDATE_SCORE,  #$FF
	MOV	<SCORE+0,       #(0-10)
	MOV	<SCORE+1,       #(0-10)
	MOV	<SCORE+2,       #(0-10)
	MOV	<SCORE+3,       #(0-10)
	MOV	<SCORE+4,       #(0-10)
	MOV	<SCORE+5,       #(0-10)
	MOV	<SCORE+6,       #(0-10)

	LDX	<SHOOT_TBL
	MOV	<SHOOT_PAT,     COMM_TBL_PAT,X
	LDY	COMM_TBL_PARAM,X
	MOV	<SHOOT_HIT_Y,   COMM_HIT_YOFS,Y
	MOV	<SHOOT_HIT_H,   COMM_HIT_HEIGHT,Y

	; A[pbg
	LDA	<ARM_LEVEL
	LSR	A
	LSR	A
	LSR	A
	TAX
	MOV	<ARM_PAL, .ARM_PAL_DATA,X

	; Q[ʕ`
	MOV	MMC5_PRG_8000, #$80+BANK(DRAW_GAME_SCREEN)
	JSR	DRAW_GAME_SCREEN

	; pbg
	WRITE_PAL	 0,  2
	WRITE_PAL	 4, 12
	WRITE_PAL	 8,  0
	WRITE_PAL	12,  3
	WRITE_PAL	16,  7
	WRITE_PAL	20,  8
	WRITE_PAL	24,  9
	WRITE_PAL	28, 13

	; ǃXN[^XN쐬
	JSR	CRE_WALL_SCROLL

	; Vo[z[N쐬
	JSR	CRE_SILVER_HAWK

	; {Xl[e[ug RAM փRs[
	LDY	<STAGE
	MOV	MMC5_PRG_A000, .BOSS_DATA_BANK,Y
	MOV	MMC5_ERAM_MODE, #2

	LDX	#0
@@:
	MOV	$5C00,X, BOSS0_NT+$0000,X
	MOV	$5D00,X, BOSS0_NT+$0100,X
	MOV	$5E00,X, BOSS0_NT+$0200,X
	MOV	$5F00,X, BOSS0_NT+$0300,X
	INX
	BNE	@B

	MOV	MMC5_ERAM_MODE, #0

	; bZ[W\[hݒ
	MOV	<TEMP+0, #BANK_BG_BASE0
	MOV	<TEMP+1, #BANK_BG_BASE1
	MOV	<TEMP+2, #BANK_BG_BASE2
	MOV	<TEMP+3, #BANK_BG_BASE3
	JSR	SET_BG_MESSAGE

	.IF	DEBUG_WARNING = 1
		JSR	CRE_WARNING
	.ELSE
		INC	SYS_STATUS
	.ENDIF

	SYS_CHG	.SYSTEM_GAME_000

	JMP	.WAIT_EXIT


.SYSTEM_GAME_000:
	LDA	<SYS_STATUS
	BNE	@F
	SYS_RET

@@:
	; ǃtF[hC^XN쐬
	JSR	CRE_WALL_FADEIN

	; {X쐬
	JSR	CRE_BOSS

	; Ƃ肠G
;#
	JSR	CRE_DRIFTING_MINE
	JSR	CRE_YAZUKS_MINE
;#

	SYS_CHG	SYSTEM_WAIT


SYSTEM_WAIT:
	SYS_RET


SYSTEM_GAMEOVER:
	MOV	<SYS_STATUS, #(60*2)

	SYS_CHG	.SYSTEM_GAMEOVER_000
	SYS_RET


.SYSTEM_GAMEOVER_000:
	DEC	<SYS_STATUS
	BNE	@F

	SYS_CHG	.SYSTEM_GAMEOVER_100

	; S^XNj
	JSR	INI_TASK_NO

	; bZ[W[hݒ
	MOV	<TEMP+0, #BANK_FONT0
	MOV	<TEMP+1, #BANK_FONT1
	MOV	<TEMP+2, #BANK_FONT2
	MOV	<TEMP+3, #BANK_FONT3
	JSR	SET_BG_MESSAGE

	; ǃXN[^XN쐬
	JSR	CRE_WALL_SCROLL

	; Q[I[o[`
	VRAM_PROC_ADD	.VRAM_PROC_DRAW_GAMEOVER

	MOV	<SYS_STATUS, #(60*4)
@@:
	SYS_RET


.SYSTEM_GAMEOVER_100:
	LDA	#(PAD_START+PAD_A)
	BIT	<PAD_ONCE
	BNE	@F

	DEC	<SYS_STATUS
	BEQ	@F

	SYS_RET

@@:
	SYS_CHG	SYSTEM_TITLE

	; S^XNj
	JSR	INI_TASK_NO

	; ʏ탂[hݒ
	JSR	SET_BG_NORMAL
	SYS_RET


; ------------------------------------------------ 
;   Q[I[o[`                             
; ------------------------------------------------ 
.VRAM_PROC_DRAW_GAMEOVER:
	SET_VRAM_ADDR	$2187
	MOV	PPU_REG_VRAM_DATA, #$8E
	MOV	PPU_REG_VRAM_DATA, #$8F
	MOV	PPU_REG_VRAM_DATA, #$82
	MOV	PPU_REG_VRAM_DATA, #$83
	MOV	PPU_REG_VRAM_DATA, #$AA
	MOV	PPU_REG_VRAM_DATA, #$AB
	MOV	PPU_REG_VRAM_DATA, #$8A
	MOV	PPU_REG_VRAM_DATA, #$8B

	SET_VRAM_ADDR	$2191
	MOV	PPU_REG_VRAM_DATA, #$AE
	MOV	PPU_REG_VRAM_DATA, #$AF
	MOV	PPU_REG_VRAM_DATA, #$CC
	MOV	PPU_REG_VRAM_DATA, #$CD
	MOV	PPU_REG_VRAM_DATA, #$8A
	MOV	PPU_REG_VRAM_DATA, #$8B
	MOV	PPU_REG_VRAM_DATA, #$C4
	MOV	PPU_REG_VRAM_DATA, #$C5

	SET_VRAM_ADDR	$21A7
	MOV	PPU_REG_VRAM_DATA, #$9E
	MOV	PPU_REG_VRAM_DATA, #$9F
	MOV	PPU_REG_VRAM_DATA, #$92
	MOV	PPU_REG_VRAM_DATA, #$93
	MOV	PPU_REG_VRAM_DATA, #$BA
	MOV	PPU_REG_VRAM_DATA, #$BB
	MOV	PPU_REG_VRAM_DATA, #$9A
	MOV	PPU_REG_VRAM_DATA, #$9B

	SET_VRAM_ADDR	$21B1
	MOV	PPU_REG_VRAM_DATA, #$BE
	MOV	PPU_REG_VRAM_DATA, #$BF
	MOV	PPU_REG_VRAM_DATA, #$DC
	MOV	PPU_REG_VRAM_DATA, #$DD
	MOV	PPU_REG_VRAM_DATA, #$9A
	MOV	PPU_REG_VRAM_DATA, #$9B
	MOV	PPU_REG_VRAM_DATA, #$D4
	MOV	PPU_REG_VRAM_DATA, #$D5
	VRAM_PROC_RET


.TITLE_CURSOR_YPOS:	.DB	19*8-1
			.DB	22*8-1
			.DB	23*8-1
			.DB	24*8-1
			.DB	25*8-1

.TITLE_CURSOR_DOWN:	.DB	1, 2, 3, 4, 0, -1, -1, -1
.TITLE_CURSOR_UP:	.DB	4, 0, 1, 2, 3, -1, -1, -1

.TITLE_SEL_A_H:		.DB	HIGH(.TITLE_SEL_GAMESTART), HIGH(.TITLE_SEL_NONE),   HIGH(.TITLE_SEL_WEAPON_A),  HIGH(.TITLE_SEL_WEAPON_A),   HIGH(.TITLE_SEL_WEAPON_A)
.TITLE_SEL_A_L:		.DB	 LOW(.TITLE_SEL_GAMESTART),  LOW(.TITLE_SEL_NONE),    LOW(.TITLE_SEL_WEAPON_A),   LOW(.TITLE_SEL_WEAPON_A),    LOW(.TITLE_SEL_WEAPON_A)

.TITLE_SEL_L_H:		.DB	HIGH(.TITLE_SEL_NONE),      HIGH(.TITLE_SEL_ZONE_L), HIGH(.TITLE_SEL_WEAPON_L),  HIGH(.TITLE_SEL_WEAPON_L),   HIGH(.TITLE_SEL_WEAPON_L)
.TITLE_SEL_L_L:		.DB	 LOW(.TITLE_SEL_NONE),       LOW(.TITLE_SEL_ZONE_L),  LOW(.TITLE_SEL_WEAPON_L),   LOW(.TITLE_SEL_WEAPON_L),    LOW(.TITLE_SEL_WEAPON_L)

.TITLE_SEL_R_H:		.DB	HIGH(.TITLE_SEL_NONE),      HIGH(.TITLE_SEL_ZONE_R), HIGH(.TITLE_SEL_WEAPON_R),  HIGH(.TITLE_SEL_WEAPON_R),   HIGH(.TITLE_SEL_WEAPON_R)
.TITLE_SEL_R_L:		.DB	 LOW(.TITLE_SEL_NONE),       LOW(.TITLE_SEL_ZONE_R),  LOW(.TITLE_SEL_WEAPON_R),   LOW(.TITLE_SEL_WEAPON_R),    LOW(.TITLE_SEL_WEAPON_R)

.ARM_PAL_DATA:		.DB	13, 16, 19

.BOSS_DATA_BANK:	.DB	$80+BANK(BOSS0)
			.DB	$80+BANK(BOSS1)
			.DB	$80+BANK(BOSS2)
.BOSS_DATA_BANK_END:

.SHOOTINFO_TBL:		.DB	COMM_TBL_MISSILE0		; ~TCFxO
			.DB	COMM_TBL_MISSILE1		;           xP
			.DB	COMM_TBL_MISSILE2		;           xQ
			.DB	COMM_TBL_MISSILE2		;           xR
			.DB	COMM_TBL_MISSILE3		;           xS
			.DB	COMM_TBL_MISSILE4		;           xT
			.DB	COMM_TBL_MISSILE4		;           xU
			.DB	COMM_TBL_MISSILE5		;           xV
			.DB	COMM_TBL_LASER0			; [U[FxO
			.DB	COMM_TBL_LASER0			;           xP
			.DB	COMM_TBL_LASER1			;           xQ
			.DB	COMM_TBL_LASER1			;           xR
			.DB	COMM_TBL_LASER1			;           xS
			.DB	COMM_TBL_LASER2			;           xT
			.DB	COMM_TBL_LASER2			;           xU
			.DB	COMM_TBL_LASER3			;           xV
			.DB	COMM_TBL_WAVE0			; EF[uFxO
			.DB	COMM_TBL_WAVE0			;           xP
			.DB	COMM_TBL_WAVE1			;           xQ
			.DB	COMM_TBL_WAVE1			;           xR
			.DB	COMM_TBL_WAVE2			;           xS
			.DB	COMM_TBL_WAVE2			;           xT
			.DB	COMM_TBL_WAVE3			;           xU
			.DB	COMM_TBL_WAVE3			;           xV

.SHOOTINFO_SPEED:	.DB	7				; ~TCFxO
			.DB	7				;           xP
			.DB	7				;           xQ
			.DB	8				;           xR
			.DB	8				;           xS
			.DB	8				;           xT
			.DB	9				;           xU
			.DB	9				;           xV
			.DB	7				; [U[FxO
			.DB	7				;           xP
			.DB	7				;           xQ
			.DB	7				;           xR
			.DB	8				;           xS
			.DB	8				;           xT
			.DB	8				;           xU
			.DB	8				;           xV
			.DB	7				; EF[uFxO
			.DB	7				;           xP
			.DB	7				;           xQ
			.DB	8				;           xR
			.DB	8				;           xS
			.DB	8				;           xT
			.DB	8				;           xU
			.DB	8				;           xV

.SHOOTINFO_SPEED_F:	.DB	  0				; ~TCFxO
			.DB	 85				;           xP
			.DB	170				;           xQ
			.DB	  0				;           xR
			.DB	 85				;           xS
			.DB	170				;           xT
			.DB	  0				;           xU
			.DB	 85				;           xV
			.DB	 85				; [U[FxO
			.DB	 85				;           xP
			.DB	170				;           xQ
			.DB	170				;           xR
			.DB	  0				;           xS
			.DB	  0				;           xT
			.DB	 85				;           xU
			.DB	 85				;           xV
			.DB	 85				; EF[uFxO
			.DB	170				;           xP
			.DB	170				;           xQ
			.DB	  0				;           xR
			.DB	  0				;           xS
			.DB	 85				;           xT
			.DB	 85				;           xU
			.DB	170				;           xV

.SHOOTINFO_COUNT:	.DB	4				; ~TCFxO
			.DB	4				;           xP
			.DB	4				;           xQ
			.DB	4				;           xR
			.DB	5				;           xS
			.DB	5				;           xT
			.DB	5				;           xU
			.DB	5				;           xV
			.DB	4				; [U[FxO
			.DB	4				;           xP
			.DB	4				;           xQ
			.DB	4				;           xR
			.DB	5				;           xS
			.DB	5				;           xT
			.DB	5				;           xU
			.DB	5				;           xV
			.DB	3				; EF[uFxO
			.DB	3				;           xP
			.DB	3				;           xQ
			.DB	3				;           xR
			.DB	3				;           xS
			.DB	3				;           xT
			.DB	3				;           xU
			.DB	3				;           xV
